package bbuvajava;

import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.File;
import java.io.FileNotFoundException;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;
import java.io.Serializable;
import java.text.DecimalFormat;
import java.text.ParseException;
import java.text.SimpleDateFormat;
import java.util.ArrayList;
import java.util.Date;
import java.util.Iterator;
import java.util.List;
import java.util.logging.Level;
import java.util.logging.Logger;
import javax.swing.Popup;

// <editor-fold defaultstate="collapsed" desc=" UML Marker "> 
// #[regen=yes,id=DCE.D71FF537-295C-7D6F-EFC0-8EAFE4E2859A]
// </editor-fold> 
public class Sucursal implements Serializable {

    //Tratamiento Cajas
    private int numCajas;
    // <editor-fold defaultstate="collapsed" desc=" UML Marker "> 
    // #[regen=yes,id=DCE.2126ECC4-26B7-B052-6487-3F4DD609ED82]
    // </editor-fold> 
    private List<Caja> mCaja;             // KIKO: Aquí cambiaría a varias cajas!!! es decir un arrayList!!!

    // <editor-fold defaultstate="collapsed" desc=" UML Marker "> 
    // #[regen=yes,id=DCE.BFEA6AA5-2FFC-D303-1653-B4566FEA7AF0]
    // </editor-fold> 
    private List<Empleado> mEmpleado;      //KIKO: Cambiado a arraylist, tendrá varios empleados no????
    // </editor-fold> 
    private List<Producto> AP;
    private List<Cliente> AC;
    //private ArrayList<Caja> mCajas;
    private ArrayList<Remesa> mRemesas;
    private ArrayList<ParteDiferencia> mPartesDif;
    private Caja cajaActual;
    private Caja CajaCentral;
    private String cif;
    private int id;
    ControladorBD bd = new ControladorBD();



    //PRUEBA
    Empleado e1;
    Empleado e2;
    // <editor-fold defaultstate="collapsed" desc=" UML Marker "> 
    // #[regen=yes,id=DCE.0E92E5F9-A906-BA7F-085E-FE2BB4E5635E]
    // </editor-fold> 

    public Sucursal(int id) {
        AP = new ArrayList<Producto>();               //Lista de Cuentas
        mEmpleado = new ArrayList<Empleado>();      //Lista de Empleados
        mCaja = new ArrayList<Caja>();              //Lista de Cajas
        AC = new ArrayList<Cliente>();              //Lista de Clientes
        //mCajas = new ArrayList<Caja>();             //Lista de Cajas
        mRemesas = new ArrayList<Remesa>();         //Lista de Remesas
        mPartesDif = new ArrayList<ParteDiferencia>();
        CajaCentral = new Caja(0);
        cif = "Q7150008F001";
        this.id = id;

      
    }

    public void cargarInicial(){

        //Carga de Empleados
        Empleado eDirector;
        Empleado e2;
        eDirector = new Empleado();
        e2 = new Empleado();

        eDirector.setContraseña("admin");
        eDirector.setUsuario("admin");
        eDirector.setNombre("Director");
        eDirector.setDNI("48938805A");

        e2.setContraseña("usuario"+Integer.toString(this.id+10));
        e2.setUsuario("usuario"+Integer.toString(this.id+10));
        e2.setDNI("48938806N");

        this.nuevoEmpleado(eDirector);
        this.nuevoEmpleado(e2);

        //Carga de Cajas

        int i = 0;
        while (i < 10) {
            Caja c = new Caja(i);
            setCaja(c);
            i++;
        }

        Producto p1 = new CuentaCorriente();
        Cliente c1 = new ClienteFisico();
        c1.setNombre("Julian Martinez Morillas");
        p1.setNumcuenta("20984002161000015263");
        p1.setTitular(c1);
        c1.setCuentasCliente(p1);
        setCuenta(p1);
        setCliente(c1);



        Producto p2 = new CuentaCorriente();
        Cliente c2 = new ClienteFisico();
        c2.setNombre("Javier Alvarez Cejudo");
        p2.setNumcuenta("20984002181000015264");
        p2.setTitular(c2);
        c2.setCuentasCliente(p2);
        setCuenta(p2);
        setCliente(c2);




        Producto p3 = new CuentaCorriente();
        Cliente c3 = new ClienteFisico();
        c3.setNombre("Martin Rivas Nistal");
        p3.setNumcuenta("20984002141000015265");
        p3.setTitular(c3);
        c3.setCuentasCliente(p3);
        setCuenta(p3);
        setCliente(c3);




        Producto p4 = new CuentaCorriente();
        Cliente c4 = new ClienteFisico();
        c4.setNombre("Alicia Rivas Cano");
        ClienteFisico CF = (ClienteFisico) c4;
        p4.setNumcuenta("20984002131000015266");
        p4.setTitular(c4);
        c4.setCuentasCliente(p4);
        setCuenta(p4);
        setCliente(c4);




        Producto p5 = new CuentaCorriente();
        Cliente c5 = new ClienteFisico();
        c5.setNombre("Julia Morente Castro");
        p5.setNumcuenta("20984002151000015267");
        p5.setTitular(c5);
        c5.setCuentasCliente(p5);
        setCuenta(p5);
        setCliente(c5);




        Producto p6 = new CuentaCorriente();
        Cliente c6 = new ClienteFisico();
        c6.setNombre("Antonio Recio Odon");
        p6.setNumcuenta("20984002181000015268");
        p6.setTitular(c6);
        c6.setCuentasCliente(p6);
        setCuenta(p6);
        setCliente(c6);




        Producto p7 = new CuentaCorriente();
        Cliente c7 = new ClienteFisico();
        c7.setNombre("Luisa Fernandez Ruiz");
        p7.setNumcuenta("20984002191000015269");
        p7.setTitular(c7);
        c7.setCuentasCliente(p7);
        setCuenta(p7);
        setCliente(c7);




        Producto p8 = new CuentaCorriente();
        Cliente c8 = new ClienteFisico();
        c8.setNombre("Antonio Martin Ares");
        p8.setNumcuenta("20984002141000015270");
        p8.setTitular(c8);
        c8.setCuentasCliente(p8);
        setCuenta(p8);
        setCliente(c8);




        Producto p9 = new CuentaCorriente();
        Cliente c9 = new ClienteFisico();
        c9.setNombre("Gabriel Mercado Condal");
        p9.setNumcuenta("20984002151000015271");
        p9.setTitular(c9);
        c9.setCuentasCliente(p9);
        setCuenta(p9);
        setCliente(c9);




        Producto p10 = new CuentaCorriente();
        Cliente c10 = new ClienteFisico();
        c10.setNombre("Pedro Villar Torres");
        p10.setNumcuenta("20984002181000015272");
        p10.setTitular(c10);
        c10.setCuentasCliente(p10);
        setCuenta(p10);
        setCliente(c10);




        Producto p11 = new CuentaCorriente();
        Cliente c11 = new ClienteFisico();
        c11.setNombre("Maria Castilla Ramos");
        p11.setNumcuenta("20984002171000015273");
        p11.setTitular(c11);
        c11.setCuentasCliente(p11);
        setCuenta(p11);
        setCliente(c11);




        Producto p12 = new CuentaCorriente();
        Cliente c12 = new ClienteFisico();
        c12.setNombre("Isabel Torres Ruiz");
        p12.setNumcuenta("20984002131000015274");
        p12.setTitular(c12);
        c12.setCuentasCliente(p12);
        setCuenta(p12);
        setCliente(c12);




        Producto p13 = new CuentaCorriente();
        Cliente c13 = new ClienteFisico();
        c13.setNombre("Ana Castro Cano");
        p13.setNumcuenta("20984002181000015275");
        p13.setTitular(c13);
        c13.setCuentasCliente(p13);
        setCuenta(p13);
        setCliente(c13);




        Producto p14 = new CuentaCorriente();
        Cliente c14 = new ClienteFisico();
        c14.setNombre("Luis Canseco Roldan");
        p14.setNumcuenta("20984002171000015276");
        p14.setTitular(c14);
        c14.setCuentasCliente(p14);
        setCuenta(p14);
        setCliente(c14);




        Producto p15 = new CuentaCorriente();
        Cliente c15 = new ClienteFisico();
        c15.setNombre("Olivia Martinez Fernandez");
        p15.setNumcuenta("20984002181000015277");
        p15.setTitular(c15);
        c15.setCuentasCliente(p15);
        setCuenta(p15);
        setCliente(c15);




        Producto p16 = new CuentaCorriente();
        Cliente c16 = new ClienteJuridico();
        c16.setNombre("Universidad de Huelva");
        p16.setNumcuenta("20981001242000024145");
        p16.setTitular(c16);
        c16.setCuentasCliente(p16);
        setCuenta(p16);
        setCliente(c16);




        Producto p17 = new CuentaCorriente();
        Cliente c17 = new ClienteJuridico();
        c17.setNombre("TELEFONICA DE ESPANA, S.A.U.");
        p17.setNumcuenta("20981003821540005128");
        p17.setTitular(c17);
        c17.setCuentasCliente(p17);
        setCuenta(p17);
        setCliente(c17);




        Producto p18 = new CuentaCorriente();
        Cliente c18 = new ClienteJuridico();
        c18.setNombre("Telefónica Moviles");
        p18.setNumcuenta("20980002210007125226");
        p18.setTitular(c18);
        c18.setCuentasCliente(p18);
        setCuenta(p18);
        setCliente(c18);




        Producto p19 = new CuentaCorriente();
        Cliente c19 = new ClienteFisico();
        c19.setNombre("Canal Satelite Digital, SL");
        p19.setNumcuenta("20980002260000564814");
        p19.setTitular(c19);
        c19.setCuentasCliente(p19);
        setCuenta(p19);
        setCliente(c19);




        Producto p20 = new CuentaCorriente();
        Cliente c20 = new ClienteFisico();
        c20.setNombre("ENDESA ENERGIA XXI, S.L.");
        p20.setNumcuenta("20980003410000425188");
        p20.setTitular(c20);
        c20.setCuentasCliente(p20);
        setCuenta(p20);
        setCliente(c20);




        Producto p21 = new CuentaCorriente();
        Cliente c21 = new ClienteFisico();
        c21.setNombre("El Corte Inglés");
        p21.setNumcuenta("20980005620000954125");
        p21.setTitular(c21);
        c21.setCuentasCliente(p21);
        setCuenta(p21);
        setCliente(c21);



    }

    // <editor-fold defaultstate="collapsed" desc=" UML Marker "> 
    // #[regen=yes,regenBody=yes,id=DCE.9C2F412D-383B-2F06-DD81-A57B931EFE1C]
    // </editor-fold> 
    public List<Caja> getCaja() {
        return mCaja;
    }

    // <editor-fold defaultstate="collapsed" desc=" UML Marker "> 
    // #[regen=yes,regenBody=yes,id=DCE.06652C15-6581-E044-BCF0-3D08635A5818]
    // </editor-fold> 
    public void setCaja(Caja val) {
       
        this.mCaja.add(val);
        bd.persist(val);

    }

    // <editor-fold defaultstate="collapsed" desc=" UML Marker "> 
    // #[regen=yes,regenBody=yes,id=DCE.0776437C-F7FB-A6ED-701A-C0F053CCA89E]
    // </editor-fold> 
    public List<Producto> getCuenta() {
        return this.AP;
    }

    // <editor-fold defaultstate="collapsed" desc=" UML Marker "> 
    // #[regen=yes,regenBody=yes,id=DCE.000AD8FB-F16D-2E97-2E89-0FB0BEF62670]
    // </editor-fold> 
    public void setCuenta(Producto val) {
        this.AP.add(val);
    }


    //*****************************************REMESAS***************************************************//


    public String verRemesaCargos(String path) throws Excepciones {
        String resumenRemesa = "";
        FileReader fr = null;
        try {
            fr = new FileReader(path);
        } catch (FileNotFoundException ex) {
            Logger.getLogger(Sucursal.class.getName()).log(Level.SEVERE, null, ex);
        }
        BufferedReader bf = new BufferedReader(fr);
        String linea;
        try {
            while ((linea = bf.readLine()) != null) {
                //Registro cabecera presentador
                if (linea.substring(0, 4).compareTo("5180") == 0) {
                    
                    resumenRemesa += linea.substring(28, 68) + "\n";
                //Registro individual obligatorio
                } else if (linea.substring(0, 4).compareTo("5680") == 0) {
                        String numCuenta = linea.substring(68,88);
                        Producto p = this.devolverCuenta(numCuenta);
                        if(p != null)
                            resumenRemesa += linea.substring(28, 68) + "\t" + linea.substring(88, 98) + "\n";
                        else{

                            throw new Excepciones("Detectada Cuenta "+numCuenta+" inexistente");
                        }

                    
                //Registro total final
                }else if(linea.substring(0,4).compareTo("5980")==0){
                    resumenRemesa += "\nTotal Remesa: "+linea.substring(88,98);
                }
            }
        } catch (IOException ex) {
            Logger.getLogger(Sucursal.class.getName()).log(Level.SEVERE, null, ex);
        }
        return resumenRemesa;
    }

    public Boolean cuadreCargos(String Path) throws ParseException,Excepciones{
          try{
                double sumaRemesa=0;
                double totalRemesa=0;
                Boolean cuadre;
                FileReader fr = null;
                fr = new FileReader(Path);
                BufferedReader bf = new BufferedReader(fr);
                String linea, buffer,aux;
                while ((linea = bf.readLine()) != null) {
                     buffer=linea.substring(0,4);
                     if(buffer.compareTo("5680")==0){
                          //Registro individual obligatorio
                         DecimalFormat df1=new DecimalFormat("#######,##");
                         Number n=df1.parse(linea.substring(88, 98));
                         sumaRemesa+=(n.doubleValue());

                     }
                     else if(buffer.compareTo("5980")==0){
                          //Registro total final
                         DecimalFormat df1=new DecimalFormat("#######,##");
                         Number n=df1.parse(linea.substring(88, 98));
                         totalRemesa=(n.doubleValue());
                     }
                }
                System.out.println(totalRemesa+"=="+sumaRemesa);
                if(totalRemesa-sumaRemesa<=0.01){
                    cuadre=true;
                }else{

                    cuadre=false;
                    throw new Excepciones("Cuadre de Remesa Incorrecto");
                }
                return cuadre;
          }catch (IOException ex) {
            System.out.println("Ha ocurrido una excepcion");
            Logger.getLogger(Sucursal.class.getName()).log(Level.SEVERE, null, ex);
            return false;
          }
    }

    public void incorporaRemesaCargos(String path) throws ParseException, Excepciones {
        //Cuando el usuario pulse sobre el boton validar
        if(this.cuadreCargos(path)){
            String linea;
            String fechaRemesa="";
            String numCta="";
            String numCuenta;
            String nomTitular;
            String errores="";
            Remesa r=new Remesa();
            Cliente c=new Cliente();
            FileReader fr = null;
            try {
                fr = new FileReader(path);
            } catch (FileNotFoundException ex) {
                Logger.getLogger(Sucursal.class.getName()).log(Level.SEVERE, null, ex);
            }
            BufferedReader bf = new BufferedReader(fr);
            try {
                while ((linea = bf.readLine()) != null) {
                    if (linea.substring(0, 4).compareTo("5180") == 0) {
                        //registro cabecera presentador
                        c.setNombre(linea.substring(28, 68));
                        r.setOrdenante(c);

                    } else if (linea.substring(0, 4).compareTo("5380") == 0) {
                            //Registro Cabecera del ordenante
                            fechaRemesa = linea.substring(22,28);
                        }else if (linea.substring(0,4).compareTo("5680")==0){
                            //Registro individual obligatorio
                             numCuenta = linea.substring(68, 88);
                             nomTitular = linea.substring(28,68);
                             //if(compruebaTitular(numCuenta,nomTitular)==true){
                                 OpRemesa op=new OpRemesa(c);
                                 DecimalFormat df1=new DecimalFormat("#######,##");
                                 Number n=df1.parse(linea.substring(88, 98));
                                 op.setImporte(-n.doubleValue());
                                 op.setConcepto(linea.substring(114,154));
                                 SimpleDateFormat df2=new SimpleDateFormat("ddMMyy");
                                    op.setFecha(df2.parse(fechaRemesa));
                                 //Leemos el numero de Cuenta
                                    Producto Caux;
                                    int parada = 0;
                                    int estado2 = 0;
                                    int i = 0;
                                    while (i< AP.size() && parada == 0) {
                                        Caux = AP.get(i);
                                        if (Caux.getNumcuenta().equals(numCuenta)) {
                                            Producto cu = Caux;
                                            estado2 = 1;

                                            if(cu.getMDomicializaciones() != null){
                                                int estado = 0;
                                                i = 0;
                                                while(i < cu.getMDomicializaciones().size() && estado == 0){
                                                    Domicializacion x=cu.getMDomicializaciones().get(i);
                                                    if(x.getCli().getNombre().equals(c.getNombre()))
                                                        estado = 1;
                                                    i++;
                                                }
                                                if(estado == 0){
                                                    Domicializacion d = new Domicializacion(c);
                                                    cu.nuevaDomicializacion(d);
                                                }
                                                Caux.setSaldo(Caux.getSaldo() - n.doubleValue() );

                                                Caux.setMovimientos(op);
                                                parada = 1;
                                            }
                                        }
                                        i++;
                                    }
                                    if(estado2 == 0)//No Encontro la cuenta
                                        throw new Excepciones("Cuenta Inexixtente");
                                    else{
                                        r.nuevaOpRemesa(op);
                                        this.nuevaRemesa(r);
                                    }
     
                         }
                    }
                
            } catch (IOException ex) {
                Logger.getLogger(Sucursal.class.getName()).log(Level.SEVERE, null, ex);
            }
        }

    }

    //*************************************** REMESA CARGOS********************************************//

    public String verRemesaAbonos(String Path) throws IOException, Excepciones{
        String resumenRemesa="";
        try {
            FileReader fr = null;
            fr = new FileReader(Path);
            BufferedReader bf = new BufferedReader(fr);
            String linea, buffer;
            while ((linea = bf.readLine()) != null) {
                buffer=linea.substring(0,4);
                if(buffer.compareTo("0356")==0){
                       //Registro cabecera presentador
                       buffer=linea.substring(26,29);
                       if(buffer.compareTo("001")==0){
                          //fechas,numcuenta
                          resumenRemesa+=" Envio: "+linea.substring(29,31)+"/"+linea.substring(31,33)+"/"+linea.substring(33,35);
                          resumenRemesa+=" Emision: "+linea.substring(35,37)+"/"+linea.substring(37,39)+"/"+linea.substring(39,41);
                       }
                       else if(buffer.compareTo("002")==0){
                          //nombreAbonador
                          resumenRemesa+="   "+linea.substring(29,58)+"\n\n";
                       }
                }
                else if(buffer.compareTo("0656")==0){
                      //Registro individual obligatorio
                      buffer=linea.substring(26,29);
                      if(buffer.compareTo("010")==0){
                          //importe,numcuenta
                        String numCuenta = linea.substring(41,61);
                        Producto p = this.devolverCuenta(numCuenta);
                        if(p != null)
                            resumenRemesa+="\n    NÂºCuenta: "+linea.substring(41,61)+".  Importe: "+linea.substring(30,39)+","+linea.substring(39,41);
                        else{

                            throw new Excepciones("Detectada Cuenta inexistente");
                        }
                          
                      }
                }
                else if(buffer.compareTo("0856")==0){
                     //Registro total final
                    resumenRemesa += "\n\n\tTotal Remesa: "+linea.substring(30,39)+","+linea.substring(39,41);
                 }
            }
        } catch (IOException ex) {
            Logger.getLogger(Sucursal.class.getName()).log(Level.SEVERE, null, ex);
        }
        return resumenRemesa;
    }
    
     public Boolean cuadreAbonos(String Path) throws ParseException,Excepciones{
          try{
                double sumaRemesa=0;
                double totalRemesa=0;
                Boolean cuadre;
                FileReader fr = null;
                fr = new FileReader(Path);
                BufferedReader bf = new BufferedReader(fr);
                String linea, buffer;
                while ((linea = bf.readLine()) != null) {
                     buffer=linea.substring(0,4);
                     if(buffer.compareTo("0656")==0){
                          //Registro individual obligatorio
                         buffer=linea.substring(26,29);
                         if(buffer.compareTo("010")==0){
                            DecimalFormat df1=new DecimalFormat("#######,##");
                            Number n=df1.parse(linea.substring(30, 39));
                            sumaRemesa+=(n.doubleValue());
                            }
                     }
                     else if(buffer.compareTo("0856")==0){
                          //Registro total final
                          DecimalFormat df1=new DecimalFormat("#######,##");
                          Number n=df1.parse(linea.substring(30, 39));
                          totalRemesa=(n.doubleValue());
                          System.out.println(n.doubleValue()+","+totalRemesa);
                     }
                }
                System.out.println(totalRemesa+"=="+sumaRemesa);
                if(totalRemesa-sumaRemesa<=0.01){
                    cuadre=true;
                }
                else{
                    cuadre=false;
                    throw new Excepciones("Cuadre de Remesa Incorrecto");
                }
                return cuadre;
          }catch (IOException ex) {
            System.out.println("Ha ocurrido una excepcion");
            Logger.getLogger(Sucursal.class.getName()).log(Level.SEVERE, null, ex);
            return false;
          }
    }

     
     public void incorporarRemesaAbonos(String Path) throws ParseException,Excepciones{
        try {
               if(this.cuadreAbonos(Path)){ //Excepcion cuadre
                    FileReader fr = null;
                    fr = new FileReader(Path);
                    BufferedReader bf = new BufferedReader(fr);
                    String linea;
                    String concepto="";
                    String importe="";
                    String fechaRemesa="";
                    String numCta="";
                    Remesa r=new Remesa();
                    String cuenta="";
                    Cliente c=new Cliente();
                    while ((linea = bf.readLine()) != null) {
                        String buffer;
                        buffer = linea.substring(0, 4);

                        if(buffer.compareTo("0356")==0){
                            //registro cabecera presentador
                            buffer = linea.substring(26,29);
                            if(buffer.compareTo("001")==0){
                                //leemos numero cuenta y fecha
                                cuenta=linea.substring(41,61);
                                fechaRemesa=linea.substring(35,41);
                            }
                            else if(buffer.compareTo("002")==0){
                                //leemos nombre

                                c.setNombre(linea.substring(29,58));
                                r.setOrdenante(c);
                             }
                         }
                         if(buffer.compareTo("0656")==0){
                            // registro beneficiario
                            buffer = linea.substring(26,29);
                            if(buffer.compareTo("010")==0){
                                 importe=linea.substring(30,39);
                                 numCta=linea.substring(41,61);

                            }
                            else if(buffer.compareTo("016")==0){
                                concepto=linea.substring(29,58);
                                OpRemesa op=new OpRemesa(c);
                                DecimalFormat df1=new DecimalFormat("#######,##");
                                Number n=df1.parse(importe);
                                op.setImporte(n.floatValue());
                                op.setConcepto(concepto);
                                SimpleDateFormat df2=new SimpleDateFormat("ddMMyy");
                                op.setFecha(df2.parse(fechaRemesa));

                                Producto Caux;
                                int parada = 0;
                                int i = 0;
                                while (i < AP.size() && parada == 0) {
                                    Caux = AP.get(i);
                                    if (Caux.getNumcuenta().equals(numCta)) {
                                        Caux.setSaldo(Caux.getSaldo() + n.doubleValue() );
                                        Caux.setMovimientos(op);
                                        parada = 1;
                                        if(Caux.getMDomicializaciones() != null){
                                            int estado = 0;
                                            i = 0;
                                            while(i < Caux.getMDomicializaciones().size() && estado == 0){
                                                Domicializacion x=Caux.getMDomicializaciones().get(i);
                                                if(x.getCli().getNombre().equals(c.getNombre()))
                                                    estado = 1;
                                                i++;
                                            }

                                            if(estado == 0){
                                                Domicializacion d = new Domicializacion(c);
                                                Caux.nuevaDomicializacion(d);
                                            }
                                        }
                                    }
                                    i++;
                                }
                                if(parada == 0){
                                    throw new Excepciones("Cuenta Inexistente");
                                }else{
                                    r.nuevaOpRemesa(op);
                                    this.nuevaRemesa(r);
                                }
                                  
                        }
                }
            }
            
         }
            
        } catch (IOException ex) {
            Logger.getLogger(Sucursal.class.getName()).log(Level.SEVERE, null, ex);
            System.out.println("Se ha producido una excepcion al validar la remesa.");
        }

}


      public void CrearRemesaTransferenciasExternas(String Path) throws IOException, ParseException{
      String sFichero = Path;
      File fichero = new File(sFichero);
      if (fichero.exists()==false) {
             BufferedWriter bw = new BufferedWriter(new FileWriter(sFichero));
             bw.write("0356 ");
             bw.write(this.getCif());
             bw.write("            001");
             Date a=new Date();
             String dia=String.valueOf(a.getDate());
             String mes=String.valueOf(a.getMonth());
             String anio=String.valueOf(a.getYear());
             String fecha=(dia+mes+anio);
             bw.write(fecha);
             bw.write(fecha);
             bw.write("********************  **");
             bw.newLine();
             bw.write("0356 ");
             bw.write(this.getCif());
             bw.write("            002BANCOBBUVASUCPROGRAMA2");
             double importeTotal=0;
             Producto p;
             Movimiento mov;
             TransferenciaExterna te;
             int i = 0;
             int j;
             while(i < this.AP.size()){
                p  = this.AP.get(i);
                    j = 0;
                    while(j < p.getMovimientos().size()){
                        mov = p.getMovimientos().get(j);
                        if(mov instanceof TransferenciaExterna){
                            te = (TransferenciaExterna)mov;
                            if(!te.isActivo()){
                            bw.newLine();
                            bw.write("0656 "+this.getCif());
                            bw.write("            010");
                            String importe= Double.toString(te.getImporteDestino());
                             //double im=Float.parseFloat(importe);
                             importeTotal+=te.getImporteDestino();
                             System.out.println(importe);
                             int dif=12-importe.length();
                             System.out.println(String.valueOf(dif));
                             for(int l=0;l<dif;l++){
                                 bw.write("0");
                             }
                             for(int z=0;z<importe.length();z++){
                                 if(importe.charAt(z)!='.')
                                     bw.write(importe.charAt(z));

                             }
                             bw.write(te.getNumCuenta()+"  **");
                             bw.newLine();
                             bw.write("0656 "+this.getCif());
                             bw.write("            011");
                             bw.write(te.getBeneficiario());
                             bw.newLine();
                             bw.write("0656 "+this.getCif());
                             bw.write("            016");
                             bw.write(te.getConcepto());
                        }
                    }
                        j++;
             }
                    i++;
           }
           bw.newLine();
             bw.write("0856 ");
             bw.write(this.getCif());
             bw.write("            ");
             String importeT=String.valueOf(importeTotal);
             int dif2=12-importeT.length();
             for(int k=0;k<dif2;k++){
                  bw.write("0");
             }
              for(int u=0;u<importeT.length();u++){
                     if(importeT.charAt(u)!='.'){
                         bw.write(importeT.charAt(u));
                     }
              }
             bw.close();
        }
 }


     //********************FIN REMESAS*************************************//

    public Producto devuelveCuenta(String numCuenta) {
        int parada = 1;
        Producto Caux = null;
        int i = 0;
        while (i < this.getCuenta().size() && parada == 1) {
            Caux = this.getCuenta().get(i);
            if (Caux.getNumcuenta().equals(numCuenta)) {
                parada = 0;

            }
            i++;

        }
        if (parada == 1) {
            Caux = null;
        }

        return Caux;
    }

    /**
     * @return the AC
     */
    public List<Cliente> getCliente() {
        return AC;
    }

    /**
     * @param AC the AC to set
     */
    public void setCliente(Cliente val) {
        this.AC.add(val);
        bd.persist(val);

    }
    public List<Producto> busquedaProductosCliente(String datosClte, int tipoBusq) {
        int i = 0;
        //while (iterador.hasNext()) {
        while(i < this.AC.size()){
            //Cliente c = (Cliente) iterador.next();
            Cliente c = AC.get(i);

            if (tipoBusq == 1) {

                    if (c.getDNI() != null) {
                        if (c.getDNI().equals(datosClte)) {
                            return c.getCuentasCliente();
                        }
                    }

                    if (c.getCIF() != null) {
                        if (c.getCIF().compareToIgnoreCase(datosClte) == 0) {
                            return c.getCuentasCliente();
                        }
                    }
            } else {
                if (tipoBusq == 2) {
                    if (c.getNombre().equals(datosClte)) {
                        return c.getCuentasCliente();
                    }
                }
            }
            i++;

        }
        return null;


    }

    public boolean compruebaTitular(String cuenta,String titular){
        List<Producto> Auxp;
        Auxp = busquedaProductosCliente(titular, 2);
        Producto p;
        int i = 0;
        while(i < Auxp.size()){
            p = Auxp.get(i);
            if(p.getNumcuenta().equals(cuenta))
                return true;
            i++;
        }
        return false;
    }

    /**
     * @return the cajaActual
     */
    public Caja getCajaActual() {
        return cajaActual;
    }

    /**
     * @param cajaActual the cajaActual to set
     */
    public void setCajaActual(Caja cajaActual) {
        this.cajaActual = cajaActual;
    }

    /**
     * @return the mRemesas
     */
    public ArrayList<Remesa> getMRemesas() {
        return mRemesas;
    }

    /**
     * @param mRemesas the mRemesas to set
     */
    public void setMRemesas(ArrayList<Remesa> mRemesas) {
        this.mRemesas = mRemesas;
    }

    public void nuevaRemesa(Remesa r){
        this.mRemesas.add(r);
    }

    /**
     * @return the CajaCentral
     */
    public Caja getCajaCentral() {
        return CajaCentral;
    }

    /**
     * @param CajaCentral the CajaCentral to set
     */
    public void setCajaCentral(Caja CajaCentral) {
        this.CajaCentral = CajaCentral;
    }

    /**
     * @return the mPartesDif
     */
    public ArrayList<ParteDiferencia> getMPartesDif() {
        return mPartesDif;
    }

    /**
     * @param mPartesDif the mPartesDif to set
     */
    public void setMPartesDif(ArrayList<ParteDiferencia> mPartesDif) {
        this.mPartesDif = mPartesDif;
    }

    public void nuevoParteDif(ParteDiferencia pd){
        this.mPartesDif.add(pd);
    }

    /**
     * @return the cif
     */
    public String getCif() {
        return cif;
    }

    /**
     * @param cif the cif to set
     */
    public void setCif(String cif) {
        this.cif = cif;
    }

    /**
     * @return the id
     */
    public int getId() {
        return id;
    }

    /**
     * @param id the id to set
     */
    public void setId(int id) {
        this.id = id;
    }

    /**
     * @return the mEmpleado
     */
    public List<Empleado> getMEmpleado() {
        return mEmpleado;
    }

    public Producto devolverCuenta(String numc){
        Producto p;
        int i = 0;
        while(i < this.AP.size()){
            if(this.AP.get(i).getNumcuenta().equals(numc))
                return this.AP.get(i);
            i++;

        }
        return null;
    }

    /**
     * @param mEmpleado the mEmpleado to set
     */
    public void setMEmpleado(List<Empleado> mEmpleado) {
        this.mEmpleado = mEmpleado;
    }

    public void nuevoEmpleado(Empleado emp){
        this.mEmpleado.add(emp);
        bd.persist(emp);
    }

    

    public void query(){
        if(bd.getData_Cliente() != null)
            this.AC = bd.getData_Cliente();      
        if(bd.getData_Empleado() != null)
            this.mEmpleado = bd.getData_Empleado();
        if(bd.getData_Caja() != null)
            this.mCaja = bd.getData_Caja();
         }
}

